Unit qtsve_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc;

procedure qtsve(var RINT :Array of Extended; var X :Array of Extended;
                N :Integer; var F :Array of Extended);

implementation

procedure qtsve(var RINT :Array of Extended; var X :Array of Extended;
                N :Integer; var F :Array of Extended);
var
I :Integer;
F12,A,A1,A2,B,X1 :Extended;
label
_1;
begin
RINT[0] := 0;
X1 := (X[1]-X[0])/2.e0;
F12 := F[0]*((X1-X[1])*(X1-X[2])*(X1-X[3]))/((X[0]-X[1])*
    (X[0]-X[2])*(X[0]-X[3]))+F[1]*((X1-X[0])*(X1-X[2])*
    (X1-X[3]))/((X[1]-X[0])*(X[1]-X[2])*(X[1]-X[3]))+F[2]*
    ((X1-X[0])*(X1-X[1])*(X1-X[3]))/((X[2]-X[0])*(X[2]-
    X[1])*(X[2]-X[3]))+F[3]*((X1-X[0])*(X1-X[1])*(X1-X[2])
    )/((X[3]-X[0])*(X[3]-X[1])*(X[3]-X[2]));
RINT[1] := (F[0]+4.e0*F12+F[1])*(X[1]-X[0])/6.e0;
A1 := X[1]-X[0];
for I:=3 to N do
 begin
  A := X[I-1]-X[I-3];
  B := A*A;
  A2 := X[I-1]-X[I-2];
  RINT[I-1] := RINT[I-3]+F[I-3]*(-B/6.e0+A*A1/2.e0)/A1+F[I-2]
    *(A*B/6.e0)/(A2*A1)+F[I-1]*(B/3.e0-A*A1/2.e0)/A2;
  A1 := A2;
_1:
 end;
end;

end.
